package org.apache.bcel.classfile;

import java.io.DataOutputStream;
import java.io.IOException;
import java.io.DataInput;

public final class ConstantFloat extends Constant implements ConstantObject
{
    private float bytes;
    
    public ConstantFloat(final ConstantFloat c) {
        this(c.getBytes());
    }
    
    ConstantFloat(final DataInput file) throws IOException {
        this(file.readFloat());
    }
    
    public ConstantFloat(final float bytes) {
        super((byte)4);
        this.bytes = bytes;
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitConstantFloat(this);
    }
    
    @Override
    public void dump(final DataOutputStream file) throws IOException {
        file.writeByte(super.getTag());
        file.writeFloat(this.bytes);
    }
    
    public float getBytes() {
        return this.bytes;
    }
    
    @Override
    public Object getConstantValue(final ConstantPool cp) {
        return this.bytes;
    }
    
    public void setBytes(final float bytes) {
        this.bytes = bytes;
    }
    
    @Override
    public String toString() {
        return super.toString() + "(bytes = " + this.bytes + ")";
    }
}
